Index: java/main/src/main/java/com/framsticks/gui/tree/TreeModel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/TreeModel.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/tree/TreeModel.java	(revision 99)
@@ -0,0 +1,229 @@
+package com.framsticks.gui.tree;
+
+// import java.util.Enumeration;
+import java.util.Iterator;
+import java.util.LinkedList;
+import java.util.List;
+
+import javax.swing.event.TreeModelEvent;
+import javax.swing.event.TreeModelListener;
+import javax.swing.tree.TreePath;
+
+import org.apache.log4j.Logger;
+
+
+import com.framsticks.core.Node;
+import com.framsticks.core.Path;
+import com.framsticks.core.Tree;
+import com.framsticks.core.TreeOperations;
+import com.framsticks.gui.Frame;
+import com.framsticks.params.AccessInterface;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.UnsupportedOperationException;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.lang.Casting;
+
+public class TreeModel implements javax.swing.tree.TreeModel {
+	private static final Logger log = Logger.getLogger(TreeModel.class);
+
+
+	protected List<TreeModelListener> listeners = new LinkedList<>();
+
+	protected final Frame frame;
+
+	/**
+	 * @param frame
+	 */
+	public TreeModel(Frame frame) {
+		this.frame = frame;
+	}
+
+	@Override
+	public void addTreeModelListener(TreeModelListener listener) {
+		listeners.add(listener);
+	}
+
+	@Override
+	public AbstractNode getChild(Object parent, int number) {
+		return Casting.assertCast(AbstractNode.class, parent).getChild(number);
+	}
+
+	@Override
+	public int getChildCount(Object parent) {
+		return Casting.assertCast(AbstractNode.class, parent).getChildCount();
+	}
+
+	@Override
+	public int getIndexOfChild(Object parent, Object child) {
+		if ((parent == null) || (child == null)) {
+			return -1;
+		}
+		return Casting.assertCast(AbstractNode.class, parent).getIndexOfChild(Casting.assertCast(AbstractNode.class, child));
+	}
+
+	@Override
+	public MetaNode getRoot() {
+		return frame.getRootNode();
+	}
+
+	@Override
+	public boolean isLeaf(Object node) {
+		return Casting.assertCast(AbstractNode.class, node).isLeaf();
+	}
+
+	@Override
+	public void removeTreeModelListener(TreeModelListener listener) {
+		listeners.remove(listener);
+	}
+
+	@Override
+	public void valueForPathChanged(TreePath path, Object value) {
+		throw new UnsupportedOperationException().msg("changing value of tree node");
+	}
+
+
+	protected boolean changing = false;
+
+	public void nodeStructureChanged(TreePath treePath) {
+		if (treePath == null) {
+			return;
+		}
+		assert frame.isActive();
+
+		changing = true;
+		log.debug("changing: " + treePath);
+		// Enumeration<TreePath> expanded = frame.jtree.getExpandedDescendants(treePath);
+		TreePath selection = frame.getJtree().getSelectionPath();
+
+		for (TreeModelListener listener : listeners) {
+			listener.treeStructureChanged(new TreeModelEvent(this, treePath));
+		}
+		// if (expanded != null) {
+		// 	while (expanded.hasMoreElements()) {
+		// 		TreePath expansion = expanded.nextElement();
+		// 		// log.info("reexpanding: " + expansion);
+		// 		frame.jtree.expandPath(expansion);
+		// 	}
+		// }
+		if (selection != null) {
+			frame.getJtree().setSelectionPath(selection);
+		}
+		changing = false;
+	}
+
+	public Path convertToPath(TreePath treePath) {
+		final Object[] components = treePath.getPath();
+		assert components[0] == frame.getRootNode();
+		if (components.length == 1) {
+			return null;
+		}
+		Path.PathBuilder builder = Path.build();
+		builder.tree(Casting.assertCast(TreeNode.class, components[1]).getTree());
+		List<Node> nodes = new LinkedList<>();
+		for (int i = 1; i < components.length; ++i) {
+			TreeNode treeNode = Casting.tryCast(TreeNode.class, components[i]);
+			if (treeNode == null) {
+				return null;
+			}
+			Node node = treeNode.tryCreateNode();
+			if (node == null) {
+				throw new FramsticksException().msg("failed to recreate path").arg("treePath", treePath);
+			}
+			nodes.add(node);
+		}
+		builder.buildUpTo(nodes, null);
+
+		return builder.finish();
+	}
+
+	public TreePath convertToTreePath(Path path) {
+		assert frame.isActive();
+
+		List<Object> accumulator = new LinkedList<Object>();
+		accumulator.add(getRoot());
+
+		for (AbstractNode r : getRoot().getChildren()) {
+			if (r instanceof TreeNode) {
+				TreeNode root = (TreeNode) r;
+				if (root.getTree() == path.getTree()) {
+					accumulator.add(root);
+
+					Iterator<Node> i = path.getNodes().iterator();
+					i.next();
+					TreeNode treeNode = root;
+
+					while (i.hasNext()) {
+						Node node = i.next();
+						treeNode = treeNode.getTreeNodeForChild(node.getObject());
+						if (treeNode == null) {
+							break;
+						}
+						accumulator.add(treeNode);
+					}
+
+					break;
+				}
+			}
+		}
+		return new TreePath(accumulator.toArray());
+	}
+
+	/**
+	 * @return the changing
+	 */
+	public boolean isChanging() {
+		return changing;
+	}
+
+	public void loadChildren(Path path, boolean reload) {
+		if (path == null) {
+			return;
+		}
+		AccessInterface access = TreeOperations.bindAccess(path);
+
+		int count = access.getCompositeParamCount();
+		for (int i = 0; i < count; ++i) {
+			Path childPath = path.appendParam(access.getCompositeParam(i)).tryFindResolution();
+			loadPath(childPath, reload);
+		}
+	}
+
+	public void loadPath(Path path, boolean reload) {
+		if (path == null) {
+			return;
+		}
+		if (path.isResolved() && !reload) {
+			return;
+		}
+		path.getTree().get(path, new FutureHandler<Path>(frame) {
+			@Override
+			protected void result(Path result) {
+				final TreePath treePath = convertToTreePath(result);
+
+				nodeStructureChanged(treePath);
+				frame.updatePanelIfIsLeadSelection(treePath, result);
+			}
+		});
+	}
+
+	public void chooseTreeNode(final TreePath treePath) {
+		assert frame.isActive();
+		if (treePath == null) {
+			return;
+		}
+		if (isChanging()) {
+			return;
+		}
+
+		Path path = convertToPath(treePath);
+		if (path == null) {
+			return;
+		}
+		path = path.assureResolved();
+		final Tree tree = path.getTree();
+
+		frame.getTreeAtFrames().get(tree).useOrCreatePanel(treePath);
+		loadChildren(path, false);
+
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/tree/TreeNode.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/TreeNode.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/tree/TreeNode.java	(revision 99)
@@ -0,0 +1,349 @@
+package com.framsticks.gui.tree;
+
+import java.lang.ref.WeakReference;
+import java.util.Iterator;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.concurrent.atomic.AtomicInteger;
+
+import javax.swing.ImageIcon;
+import javax.swing.tree.TreePath;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.core.ListChange;
+import com.framsticks.core.Node;
+import com.framsticks.core.Path;
+import com.framsticks.core.Tree;
+import com.framsticks.gui.Frame;
+import com.framsticks.gui.ImageProvider;
+import com.framsticks.gui.TreeAtFrame;
+import com.framsticks.params.AccessInterface;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.EventListener;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.ValueParam;
+import com.framsticks.params.types.EventParam;
+import com.framsticks.params.types.ObjectParam;
+import com.framsticks.params.types.StringParam;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.lang.Casting;
+import com.framsticks.util.lang.Containers;
+import com.framsticks.util.lang.Pair;
+import com.framsticks.util.swing.TooltipConstructor;
+import static com.framsticks.core.TreeOperations.*;
+
+public class TreeNode extends AbstractNode {
+	private static final Logger log = Logger.getLogger(TreeNode.class);
+
+
+	protected static final AtomicInteger counter = new AtomicInteger();
+
+	protected final WeakReference<Object> reference;
+	protected final CompositeParam param;
+	protected final TreeAtFrame treeAtFrame;
+	protected final List<Pair<WeakReference<Object>, WeakReference<TreeNode>>> children = new LinkedList<>();
+	protected final int number;
+	protected final String textualPath;
+	protected final ImageIcon imageIcon;
+	protected final TreeModel treeModel;
+
+	protected final List<EventListener<?>> listeners = new LinkedList<>();
+
+	public TreeNode(TreeAtFrame treeAtFrame, Path path) {
+		path.assureResolved();
+		this.textualPath = path.getTextual();
+		this.param = path.getTop().getParam();
+		this.treeAtFrame = treeAtFrame;
+		this.treeModel = treeAtFrame.getFrame().getTreeModel();
+		this.imageIcon = ImageProvider.loadImage(TreeCellRenderer.findIconName(param));
+
+		reference = new WeakReference<Object>(path.getTop().getObject());
+		number = counter.getAndIncrement();
+
+		/** Iterate over all EventParams and for matching ValueParams register listeners. */
+		if (param instanceof ObjectParam) {
+			AccessInterface access = bindAccess(path);
+			FramsClass framsClass = access.getFramsClass();
+			for (EventParam eventParam : Containers.filterInstanceof(framsClass.getParamEntries(), EventParam.class)) {
+				if (!eventParam.getId().endsWith("_changed")) {
+					continue;
+				}
+				String valueId = eventParam.getId().substring(0, eventParam.getId().length() - 8);
+				final ValueParam valueParam = Casting.tryCast(ValueParam.class, framsClass.getParam(valueId));
+				if (valueParam == null) {
+					continue;
+				}
+				registerForEventParam(path, eventParam, valueParam);
+			}
+		}
+	}
+
+	protected <A> void tryAddListener(final Path path, final EventParam eventParam, Class<A> argumentType, final EventListener<A> listener) {
+		treeAtFrame.getTree().addListener(path, eventParam, listener, argumentType, new FutureHandler<Void>(treeAtFrame.getFrame()) {
+			@Override
+			protected void result(Void result) {
+				assert treeAtFrame.getFrame().isActive();
+				log.debug("registered gui listener for " + eventParam + " at " + path);
+				listeners.add(listener);
+			}
+		});
+	}
+
+	protected void registerForEventParam(Path path, EventParam eventParam, ValueParam valueParam) {
+		/** TODO make this listener not bind hold the reference to this TreeNode, maybe hold WeakReference internally */
+		if (valueParam instanceof PrimitiveParam) {
+
+			tryAddListener(path, eventParam, Object.class, new EventListener<Object>() {
+				@Override
+				public void action(Object argument) {
+					treeModel.loadPath(assurePath(), true);
+				}
+			});
+
+		} else if (valueParam instanceof CompositeParam) {
+
+			final CompositeParam compositeParam = (CompositeParam) valueParam;
+
+			tryAddListener(path, eventParam, ListChange.class, new EventListener<ListChange>() {
+				@Override
+				public void action(ListChange listChange) {
+					assert treeAtFrame.getTree().isActive();
+
+					final Path listPath = assurePath().appendParam(compositeParam).tryFindResolution().assureResolved();
+					log.debug("reacting to change " + listChange + " in " + listPath);
+
+					if ((listChange.getAction().equals(ListChange.Action.Modify)) && (listChange.getPosition() == -1)) {
+						// get(listPath, future);
+						return;
+					}
+					final String id = listChange.getBestIdentifier();
+
+					AccessInterface access = bindAccess(listPath);
+					switch (listChange.getAction()) {
+						case Add: {
+							tryGet(listPath.getTree(), Path.appendString(listPath.getTextual(), id), new FutureHandler<Path>(treeAtFrame.getFrame()) {
+								@Override
+								protected void result(Path result) {
+									final Frame frame = treeAtFrame.getFrame();
+									assert frame.isActive();
+									final TreePath treePath = frame.getTreeModel().convertToTreePath(listPath);
+									treeModel.nodeStructureChanged(treePath);
+									frame.updatePanelIfIsLeadSelection(treePath, listPath);
+									log.debug("added " + id + "(" + result + ") updated " + treePath);
+								}
+							});
+							break;
+						}
+						case Remove: {
+							access.set(id, null);
+							Frame frame = treeAtFrame.getFrame();
+							treeModel.nodeStructureChanged(frame.getTreeModel().convertToTreePath(listPath));
+							break;
+						}
+						case Modify: {
+							tryGet(listPath.getTree(), Path.appendString(listPath.getTextual(), id), new FutureHandler<Path>(treeAtFrame.getFrame()) {
+								@Override
+								protected void result(Path result) {
+									final Frame frame = treeAtFrame.getFrame();
+									assert frame.isActive();
+									final TreePath treePath = frame.getTreeModel().convertToTreePath(result);
+									treeModel.nodeStructureChanged(treePath);
+									frame.updatePanelIfIsLeadSelection(treePath, listPath);
+								}
+							});
+							break;
+						}
+					}
+				}
+			});
+		}
+
+	}
+
+	protected Path assurePath() {
+		return Path.to(treeAtFrame.getTree(), textualPath).assureResolved();
+	}
+
+	public Node tryCreateNode() {
+		Object child = lock();
+		if (child == null) {
+			return null;
+		}
+		return Path.to(treeAtFrame.getTree(), textualPath).assureResolved().getTop();
+	}
+
+	@Override
+	public int getChildCount() {
+		Object referent = lock();
+		if (referent == null) {
+			return 0;
+		}
+		AccessInterface access = bindAccessFor(referent);
+		final int count = access.getCompositeParamCount();
+		return count;
+	}
+
+	public TreeNode getTreeNodeForChild(Object child) {
+		Iterator<Pair<WeakReference<Object>, WeakReference<TreeNode>>> i = children.iterator();
+		while (i.hasNext()) {
+			Pair<WeakReference<Object>, WeakReference<TreeNode>> p = i.next();
+			Object object = p.first.get();
+			if (object == null) {
+				i.remove();
+				continue;
+			}
+			TreeNode treeNode = p.second.get();
+			if (treeNode == null) {
+				i.remove();
+				continue;
+			}
+			if (object == child) {
+				return treeNode;
+			}
+		}
+		return null;
+
+		// WeakReference<GuiTreeNode> resultReference = children.get(child);
+		// if (resultReference == null) {
+		//	return null;
+		// }
+		// return resultReference.get();
+	}
+
+	@Override
+	public AbstractNode getChild(int number) {
+		Object referent = lock();
+		if (referent == null) {
+			throw new FramsticksException().msg("invalid state - missing referent");
+		}
+		AccessInterface access = bindAccessFor(referent);
+
+		final int count = access.getCompositeParamCount();
+		if (number >= count) {
+			throw new FramsticksException().msg("invalid state - no child");
+		}
+
+		CompositeParam childParam = access.getCompositeParam(number);
+		Object child = access.get(childParam, Object.class);
+		if (child == null) {
+			log.debug("returning dummy node for " + childParam + " in " + referent);
+			return new EmptyNode(childParam);
+		}
+
+		TreeNode result = getTreeNodeForChild(child);
+		if (result != null) {
+			return result;
+		}
+		Path path = Path.to(treeAtFrame.getTree(), Path.appendString(textualPath, childParam.getId())).assureResolved();
+		result = new TreeNode(treeAtFrame, path);
+
+		children.add(Pair.make(new WeakReference<Object>(child), new WeakReference<TreeNode>(result)));
+
+		return result;
+
+	}
+
+	public Object lock() {
+		return reference.get();
+	}
+
+	@Override
+	public int getIndexOfChild(AbstractNode child) {
+		final TreeNode treeChild = Casting.tryCast(TreeNode.class, child);
+		if (treeChild == null) {
+			return -1;
+		}
+		final Object childObject = treeChild.lock();
+		final Object parentObject = lock();
+		if (childObject == null || parentObject == null) {
+			return -1;
+		}
+		final AccessInterface access = bindAccessFor(parentObject);
+
+		final int count = access.getCompositeParamCount();
+		for (int i = 0; i < count; ++i) {
+			Object c = access.get(access.getCompositeParam(i), Object.class);
+			if (c == childObject) {
+				return i;
+			}
+		}
+		log.debug(child + " not found in " + this);
+		return -1;
+	}
+
+	/**
+	 * @return the param
+	 */
+	public CompositeParam getParam() {
+		return param;
+	}
+
+	/**
+	 * @return the tree
+	 */
+	public Tree getTree() {
+		return treeAtFrame.getTree();
+	}
+
+
+	@Override
+	public String toString() {
+		return param.toString();
+	}
+
+	public static Node tryGetNode(TreePath treePath) {
+		return Casting.throwCast(TreeNode.class, treePath.getLastPathComponent()).tryCreateNode();
+	}
+
+	@Override
+	public boolean isLeaf() {
+		Object referent = lock();
+		if (referent == null) {
+			return true;
+		}
+		return bindAccessFor(referent).getCompositeParamCount() == 0;
+	}
+
+	protected AccessInterface bindAccessFor(Object child) {
+		return treeAtFrame.getTree().prepareAccess(param).select(child);
+	}
+
+	@Override
+	public void render(TreeCellRenderer renderer) {
+		String name = param.getId();
+
+		Object child = lock();
+		if (child != null) {
+			AccessInterface access = bindAccessFor(child);
+
+			StringParam nameParam = Casting.tryCast(StringParam.class, access.getParam("name"));
+
+			if (nameParam != null) {
+				name = access.get(nameParam, String.class);
+			}
+
+			renderer.setToolTipText(new TooltipConstructor()
+				.append("frams", access.getId())
+				.append("java", child.getClass().getCanonicalName())
+				.append("access", access.getClass().getSimpleName())
+				.append("name", name)
+				.append("id", param.getId())
+				.append("object", Integer.toHexString(System.identityHashCode(child)))
+				.append("number", number)
+				.append("textual path", textualPath)
+				.build());
+		} else {
+			renderer.setToolTipText(new TooltipConstructor()
+				.append("param", param)
+				.append("textual path", textualPath)
+				.build());
+		}
+		renderer.setText(name);
+		renderer.setIcon(imageIcon);
+
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/hosting/Cli.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/Cli.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/hosting/Cli.java	(revision 99)
@@ -0,0 +1,77 @@
+package com.framsticks.hosting;
+
+import java.util.Map;
+import java.util.TreeMap;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.communication.Response;
+import com.framsticks.communication.ServerSideResponseFuture;
+import com.framsticks.core.Path;
+import com.framsticks.core.Tree;
+import com.framsticks.params.EventListener;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.params.types.EventParam;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
+
+@FramsClassAnnotation
+public class Cli {
+	private static final Logger log =
+		Logger.getLogger(Cli.class);
+
+
+	protected int eventCounter = 0;
+	protected final Tree tree;
+	protected final ClientAtServer client;
+
+	@ParamAnnotation
+	public final Map<String, CliEvent> events = new TreeMap<>();
+
+	/**
+	 * @param tree
+	 */
+	public Cli(ClientAtServer client) {
+		this.client = client;
+		this.tree = client.getTree();
+	}
+
+	public void addListener(Path path, EventParam param, String pathPrefix, ServerSideResponseFuture responseFuture) {
+		log.debug("adding listener for " + path + ": " + param);
+
+		final CliEvent event = new CliEvent();
+		event.cli = this;
+		event.id = "e" + (eventCounter++);
+		event.path = path;
+		event.param = param;
+		event.name = pathPrefix + Path.appendString(path.getTextual(), param.getId());
+		event.pathToEvent = "/cli/events/" + event.id;
+
+		event.listener = new EventListener<Object>() {
+
+			@Override
+			public void action(Object argument) {
+				log.debug("registered event " + event + " happened with " + argument);
+
+				client.connection.sendFile(
+						"event " + event.pathToEvent + " " + event.name,
+						ClientAtServer.printToFile("", tree.getRegistry().createAccess(argument.getClass()).select(argument))
+					);
+			}
+		};
+
+		// SyncedFuture handler = new SyncedFuture<Void>(ThrowExceptionHandler.getInstance());
+		path.getTree().addListener(path, param, event.listener, Object.class, FutureHandler.doNothing(Void.class, ThrowExceptionHandler.getInstance()));
+
+		events.put(event.id, event);
+		responseFuture.pass(new Response(true, event.pathToEvent, null));
+		// handler
+	}
+
+	@Override
+	public String toString() {
+		return "CLI for " + tree;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/hosting/CliEvent.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/CliEvent.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/hosting/CliEvent.java	(revision 99)
@@ -0,0 +1,67 @@
+package com.framsticks.hosting;
+
+import com.framsticks.core.Path;
+import com.framsticks.params.EventListener;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.params.types.EventParam;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
+
+@FramsClassAnnotation
+public class CliEvent {
+
+	protected Cli cli;
+	protected String id;
+
+	protected Path path;
+	protected EventParam param;
+
+	protected String name;
+	protected String pathToEvent;
+
+	protected EventListener<Object> listener;
+	// protected String name;
+
+
+
+	/**
+	 * @param id
+	 * @param listener
+	 * @param tree
+	 * @param name
+	 * @param path
+	 * @param param
+	 */
+	public CliEvent() {
+	}
+
+	@ParamAnnotation(paramType = ProcedureParam.class)
+	public void remove() {
+		assert path.getTree().isActive();
+
+		//it should happen now
+		path.getTree().removeListener(path, param, listener, FutureHandler.doNothing(Void.class, ThrowExceptionHandler.getInstance()));
+		cli.events.remove(id);
+	}
+
+	/**
+	 * @return the id
+	 */
+	@ParamAnnotation
+	public String getId() {
+		return id;
+	}
+
+	@ParamAnnotation
+	public String getName() {
+		return id;
+	}
+
+	@Override
+	public String toString() {
+		return "event " + id + " of type " + param + " in " + path;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/hosting/ClientAtServer.java	(revision 99)
@@ -8,11 +8,15 @@
 import com.framsticks.communication.queries.GetRequest;
 import com.framsticks.communication.queries.InfoRequest;
+import com.framsticks.communication.queries.RegisterRequest;
 import com.framsticks.communication.queries.SetRequest;
+import com.framsticks.core.LocalTree;
 import com.framsticks.core.Tree;
 import com.framsticks.core.Path;
 import com.framsticks.params.*;
+import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.parsers.Savers;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.Misc;
 import com.framsticks.util.dispatching.AbstractJoinable;
 import com.framsticks.util.dispatching.Dispatching;
@@ -22,9 +26,10 @@
 import com.framsticks.util.dispatching.JoinableParent;
 import com.framsticks.util.dispatching.JoinableState;
+import com.framsticks.util.lang.FlagsUtil;
+import com.framsticks.util.lang.Strings;
+
 import static com.framsticks.core.TreeOperations.*;
 
 import java.net.Socket;
-import java.util.LinkedList;
-import java.util.List;
 
 /**
@@ -34,11 +39,56 @@
 
 	protected final Server server;
-	protected final Tree tree;
+	protected final Tree contentTree;
+	protected final Object treeRootObject;
 	protected final ServerSideManagedConnection connection;
+
+	protected final Cli cliObject;
+	protected final LocalTree rootTree;
+
+
+	protected final FramsClass rootFramsClass;
+	protected final Object root;
+	protected final String contentPrefix;
 
 	public ClientAtServer(Server server, Socket socket) {
 		this.server = server;
-		this.tree = server.hosted;
+		this.contentTree = server.hosted;
 		this.connection = new ServerSideManagedConnection(socket, this);
+
+		treeRootObject = contentTree.getAssignedRoot().getObject();
+		Misc.throwIfNull(treeRootObject);
+
+		cliObject = new Cli(this);
+		rootTree = new LocalTree();
+		// rootTree.setDispatcher(new AtOnceDispatcher<Tree>());
+		rootTree.setDispatcher(server.getHosted().getDispatcher());
+		assert rootTree.getDispatcher() != null;
+
+		final FramsClass framsClass = bindAccess(contentTree.getAssignedRoot()).getFramsClass();
+		final String id = Strings.uncapitalize(framsClass.getName());
+		contentPrefix = "/" + id;
+		final String rootFramsClassId = id + "Root";
+
+		rootFramsClass = FramsClass.build()
+			.idAndName(rootFramsClassId)
+			.param(Param.build().id(id).name(framsClass.getName()).type("o " + framsClass.getId()))
+			.param(Param.build().id("cli").name("CLI").type("o Cli"))
+			.finish();
+
+		// rootTree.putInfoIntoCache(rootFramsClass);
+		rootTree.getRegistry().putFramsClass(rootFramsClass);
+		rootTree.getRegistry().registerAndBuild(Cli.class);
+		rootTree.getRegistry().registerAndBuild(CliEvent.class);
+
+		AccessInterface access = new PropertiesAccess(rootFramsClass);
+
+		root = access.createAccessee();
+		access.select(root);
+		access.set(id, treeRootObject);
+		access.set("cli", cliObject);
+
+		rootTree.assignRootParam(access.buildParam(new ParamBuilder()).name(rootFramsClassId).finish(CompositeParam.class));
+		rootTree.assignRootObject(root);
+
 	}
 
@@ -52,14 +102,42 @@
 		assureNotEmpty(request.getPath());
 
-		tryGet(tree, request.getPath(), new FutureHandler<Path>(responseCallback) {
+		if (request.getPath().startsWith(contentPrefix)) {
+			String p = request.getPath().substring(contentPrefix.length());
+			request.path(p.equals("") ? "/" : p);
+			handleInTree(contentTree, request, responseCallback, contentPrefix);
+			return;
+		}
+
+		handleInTree(rootTree, request, responseCallback, "");
+	}
+
+	public static File printToFile(String path, AccessInterface access) {
+		ListSink sink = new ListSink();
+		access.save(sink);
+		return new File(path, new ListSource(sink.getOut()));
+	}
+
+	protected void handleInTree(final Tree tree, final ApplicationRequest request, final ServerSideResponseFuture responseCallback, final String usedPrefix) {
+
+		tryGet(tree, request.getActualPath(), new FutureHandler<Path>(responseCallback) {
 			@Override
 			protected void result(final Path path) {
 
-				if (!path.getTextual().equals(request.getPath())) {
-					throw new FramsticksException().msg("invalid path").arg("path", request.getPath());
+				if (!path.getTextual().equals(request.getActualPath())) {
+					throw new FramsticksException().msg("invalid path").arg("path", request.getActualPath());
 				}
 
 				// final AccessInterface access = tree.prepareAccess(path);
 				final AccessInterface access = bindAccess(path);
+
+				if (request instanceof GetRequest) {
+					Object result = path.getTopObject();
+					if (result != access.getSelected()) {
+						throw new FramsticksException().msg("mismatch objects during fetch").arg("path", path);
+					}
+					responseCallback.pass(new Response(true, "", File.single(printToFile(path.getTextual(), access))));
+
+					return;
+				}
 
 				if (request instanceof SetRequest) {
@@ -69,5 +147,5 @@
 						@Override
 						protected void result(Integer flag) {
-							responseCallback.pass(new Response(true, Flags.write(flag, null), null));
+							responseCallback.pass(new Response(true, FlagsUtil.write(SetStateFlags.class, flag, null), null));
 
 						}
@@ -76,17 +154,4 @@
 				}
 
-				if (request instanceof GetRequest) {
-					Object result = path.getTopObject();
-					if (result != access.getSelected()) {
-						throw new FramsticksException().msg("mismatch objects during fetch").arg("path", path);
-					}
-					List<File> files = new LinkedList<File>();
-					ListSink sink = new ListSink();
-					access.save(sink);
-					files.add(new File(path.getTextual(), new ListSource(sink.getOut())));
-					responseCallback.pass(new Response(true, "", files));
-
-					return;
-				}
 				if (request instanceof CallRequest) {
 					final CallRequest callRequest = (CallRequest) request;
@@ -107,4 +172,5 @@
 					return;
 				}
+
 				if (request instanceof InfoRequest) {
 					FramsClass framsClass = getInfo(path);
@@ -116,4 +182,11 @@
 				}
 
+				if (request instanceof RegisterRequest) {
+					RegisterRequest register = (RegisterRequest) request;
+
+					cliObject.addListener(path, access.getFramsClass().getParamEntry(register.getEventName(), EventParam.class), usedPrefix, responseCallback);
+					return;
+				}
+
 				throw new FramsticksException().msg("invalid request type: " + request.getCommand());
 			}
@@ -148,5 +221,12 @@
 	@Override
 	public void handle(FramsticksException exception) {
-		tree.handle(exception);
+		contentTree.handle(exception);
+	}
+
+	/**
+	 * @return the tree
+	 */
+	public Tree getTree() {
+		return contentTree;
 	}
 
Index: java/main/src/main/java/com/framsticks/model/Model.java
===================================================================
--- java/main/src/main/java/com/framsticks/model/Model.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/model/Model.java	(revision 99)
@@ -59,3 +59,9 @@
 	public List<NeuroConnection> getNeuroConnections() { return neuroConnections; }
 
+	@Override
+	public String toString() {
+		return "Model{" + parts.size() + ":" + joints.size() + ":" + neuroDefinitions.size() + ":" + neuroConnections.size() + "}";
+
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/params/AccessInterface.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 99)
@@ -2,4 +2,5 @@
 
 
+import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
 
@@ -39,4 +40,8 @@
 	<T> int set(ValueParam param, T value);
 
+	void reg(EventParam param, EventListener<?> listener);
+
+	void regRemove(EventParam param, EventListener<?> listener);
+
 	void setDefault(boolean numericOnly);
 
@@ -50,6 +55,4 @@
 
 	void setMax(int i);
-
-	void copyFrom(AccessInterface src);
 
 	void save(SinkInterface sink);
@@ -80,4 +83,6 @@
 	CompositeParam getCompositeParam(int number);
 
+	ParamBuilder buildParam(ParamBuilder builder);
+
 
 }
